// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ==  http://www.amdis-fem.org                                              ==
// ==                                                                        ==
// ============================================================================
//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.



/** \file PeriodicInfo.h */

#ifndef AMDIS_PERIODICINFO_H
#define AMDIS_PERIODICINFO_H

#include <map>

namespace AMDiS {

  class PeriodicInfo 
  {
  public:
    int mode;
      
    int type;

    int outputIndex;

    int neighIndex;

    std::map<int, int> vertexMap;
  };

}

#endif
