//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.


#include "MpiHelper.h"

#ifdef HAVE_PARALLEL_DOMAIN_AMDIS

namespace AMDiS {

  namespace mpi {

    void globalAdd(double &value)
    {
      double valCopy = value;
      MPI::COMM_WORLD.Allreduce(&valCopy, &value, 1, MPI_DOUBLE, MPI_SUM);
    }

    void globalAdd(int &value)
    {
      int valCopy = value;
      MPI::COMM_WORLD.Allreduce(&valCopy, &value, 1, MPI_INT, MPI_SUM);
    }
    
    void globalMin(double &value)
    {
      double valCopy = value;
      MPI::COMM_WORLD.Allreduce(&valCopy, &value, 1, MPI_DOUBLE, MPI_MIN);
    }

    void globalMin(int &value)
    {
      int valCopy = value;
      MPI::COMM_WORLD.Allreduce(&valCopy, &value, 1, MPI_INT, MPI_MIN);
    }
    
    void globalMax(double &value)
    {
      double valCopy = value;
      MPI::COMM_WORLD.Allreduce(&valCopy, &value, 1, MPI_DOUBLE, MPI_MAX);
    }

    void globalMax(int &value)
    {
      int valCopy = value;
      MPI::COMM_WORLD.Allreduce(&valCopy, &value, 1, MPI_INT, MPI_MAX);
    }

  }
}

#endif
